﻿using System.Web.Mvc;
using SyncfusionMvcApplication40.Grid;
using System.Linq;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Collections;
using System.Reflection;
using System.Collections.Generic;
using System;
using System.Threading;
using System.Reflection.Emit;
using Newtonsoft.Json;

namespace SyncfusionMvcApplication40.Controllers
{
    public class GridController : Controller
    {
        // public static List<Orders> order = new List<Orders>();
        List<Orders> order = new List<Orders>();
        private void BindDataSource()
        {
            if (order.Count == 0)
            {
                int code = 10000;
                for (int i = 1; i < 10; i++)
                {
                    order.Add(new Orders(code + 1, "AL=001FKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                    order.Add(new Orders(code + 2, "ANA$$TR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                    order.Add(new Orders(code + 3, "ANT&&ON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                    order.Add(new Orders(code + 4, "BLO**NP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                    order.Add(new Orders(code + 5, "BO@@LID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                    code += 5;
                }
            }
        }

        [Serializable]
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }
            public long OrderID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }
        public ActionResult GridFeatures()
        {

            BindDataSource();
            ViewBag.datasource = order.ToList();
            return View();
        }
       
        public void ExportToWord(string GridModel)
        {
            WordExport exp = new WordExport();
            var DataSource = new NorthwindDataContext().OrdersViews.Take(100).ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.docx", false, false, "flat-saffron");
        }
        public void ExportToPdf(string GridModel)
        {
            BindDataSource();
            //PdfExport exp = new PdfExport();
            //var DataSource = new NorthwindDataContext().OrdersViews.Take(100).ToList();
            //GridProperties obj = ConvertGridObject(GridModel);
            //exp.Export(obj, DataSource, "Export.pdf", false, false, "flat-saffron");
            GridProperties obj = ConvertGridObject(GridModel);
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            //obj.Columns.ForEach(x=>x.Field=StringReplace(x.Field));
            Type test = GetTableType(obj);
            var inst = Array.CreateInstance(test, 1);            
            string griddata = serializer.Serialize(order);
            // griddata = StringReplace(griddata);
            dynamic data = serializer.Deserialize(griddata, inst.GetType()) as object[];

            PdfExport exp = new PdfExport();
            exp.Export(obj, data, "Export.pdf", false, false, true, "flat-saffron");
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        public static Type GetTableType(GridProperties gridProperty)
        {

            // Create needed TypeBuilder helpers
            AppDomain myDomain = Thread.GetDomain();
            AssemblyName myAsmName = new AssemblyName("Anonymous");
            AssemblyBuilder myAsmBuilder = myDomain.DefineDynamicAssembly(myAsmName, AssemblyBuilderAccess.Run);
            ModuleBuilder myModBuilder = myAsmBuilder.DefineDynamicModule(myAsmName.Name);
            TypeBuilder myTypeBuilder = myModBuilder.DefineType("TestClass", TypeAttributes.Public);
            foreach (var col in gridProperty.Columns)
            {
                Type PropertyType;
                var PropertyName = col.Field;
                switch (col.Type)
                {
                    case "number":
                        PropertyType = Type.GetType("System.Decimal");
                        break;
                    case "string":
                        PropertyType = Type.GetType("System.String");
                        break;
                    case "boolean":
                        PropertyType = Type.GetType("System.Boolean");
                        break;
                    default:
                        PropertyType = Type.GetType("System.String");
                        break;
                }
                FieldBuilder PropertyFieldBuilder = myTypeBuilder.DefineField(PropertyName.ToLower(), PropertyType, FieldAttributes.Private);
                PropertyBuilder PBuilder = myTypeBuilder.DefineProperty(PropertyName, System.Reflection.PropertyAttributes.HasDefault, PropertyType, null);
                MethodAttributes getSetAttr = MethodAttributes.Public | MethodAttributes.SpecialName | MethodAttributes.HideBySig;
                MethodBuilder getPropertyBuilder = myTypeBuilder.DefineMethod("get" + PropertyName, getSetAttr, PropertyType, Type.EmptyTypes);

                // Constructing IL Code for get and set Methods.
                ILGenerator GetPropGenerator = getPropertyBuilder.GetILGenerator();
                GetPropGenerator.Emit(OpCodes.Ldarg_0);
                GetPropGenerator.Emit(OpCodes.Ldfld, PropertyFieldBuilder);
                GetPropGenerator.Emit(OpCodes.Ret);
                MethodBuilder setPropertyBuulder = myTypeBuilder.DefineMethod("set_" + PropertyName, getSetAttr, null, new Type[] { PropertyType });
                ILGenerator SetPropGenerator = setPropertyBuulder.GetILGenerator();
                SetPropGenerator.Emit(OpCodes.Ldarg_0);
                SetPropGenerator.Emit(OpCodes.Ldarg_1);
                SetPropGenerator.Emit(OpCodes.Stfld, PropertyFieldBuilder);
                SetPropGenerator.Emit(OpCodes.Ret);
                PBuilder.SetGetMethod(getPropertyBuilder);
                PBuilder.SetSetMethod(setPropertyBuulder);
            }
            ConstructorInfo objCtor = typeof(object).GetConstructor(new Type[-1 + 1]);
            ConstructorBuilder pointCtor = myTypeBuilder.DefineConstructor(MethodAttributes.Public, CallingConventions.Standard, Type.EmptyTypes);
            ILGenerator ctorIL = pointCtor.GetILGenerator();

            // Constructing IL Code for the Type Constructor.
            ctorIL.Emit(OpCodes.Ldarg_0);
            ctorIL.Emit(OpCodes.Call, objCtor);
            ctorIL.Emit(OpCodes.Ret);
            return myTypeBuilder.CreateType();
        }
    }
}